diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/rom_image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/rom_image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/rom_image_reader.cpp	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/rom_image_reader.cpp	2010-05-08 14:55:36.000000000 +0100
@@ -20,6 +20,12 @@
 #include <e32rom.h>
 #include "rom_image_reader.h"
 #include "r_rom.h"
+#if defined(WIN32)
+	#define ALLOCA _alloca
+#elif defined(__LINUX__)
+	#include <alloca.h>
+	#define ALLOCA alloca
+#endif
 
 void InflateUnCompress(unsigned char* source, int sourcesize, unsigned char* dest, int destsize);
 RomImageFSEntry::RomImageFSEntry (const char* aName) : iName(aName), iSibling(0), iChildren(0) {
@@ -86,59 +92,60 @@
 
 	*out << endl << endl;
 
-	DumpInHex("Timestamp", (iRomHdr->iTime >> 32)) ;
-	DumpInHex(" ", (iRomHdr->iTime &0xffffffff), aContinue) << endl;
+	DumpInHex(const_cast<char *>("Timestamp"), (iRomHdr->iTime >> 32)) ;
+	DumpInHex(const_cast<char *>(" "), (iRomHdr->iTime &0xffffffff), aContinue) << endl;
 
-	DumpInHex("RomBase", iRomHdr->iRomBase) << endl;
+	DumpInHex(const_cast<char *>("RomBase"), iRomHdr->iRomBase) << endl;
 
-	DumpInHex("RomSize", iRomHdr->iRomSize) << endl;
-	DumpInHex("KernelDataAddress", iRomHdr->iKernDataAddress) << endl;
-	DumpInHex("KernelLimit", iRomHdr->iKernelLimit) << endl;
-	DumpInHex("PrimaryFile", iRomHdr->iPrimaryFile) << endl;
-	DumpInHex("SecondaryFile", iRomHdr->iSecondaryFile) << endl;
-	DumpInHex("CheckSum", iRomHdr->iCheckSum) << endl;
-	DumpInHex("Hardware", iRomHdr->iHardware) << endl;
-
-	DumpInHex("Language", (TUint)(iRomHdr->iLanguage >> 32));
-	DumpInHex(" ", ((TUint)(iRomHdr->iLanguage & 0xffffffff)), aContinue) <<endl;
-
-	DumpInHex("KernelConfigFlags", iRomHdr->iKernelConfigFlags) << endl;
-	DumpInHex("RomExceptionSearchTable", iRomHdr->iRomExceptionSearchTable) << endl;
-	DumpInHex("RomHeaderSize", iRomHdr->iRomHeaderSize) << endl;
-	DumpInHex("RomSectionHeader", iRomHdr->iRomSectionHeader) << endl;
-	DumpInHex("TotalSvDataSize", iRomHdr->iTotalSvDataSize) << endl;
-	DumpInHex("VariantFile", iRomHdr->iVariantFile) << endl;
-	DumpInHex("ExtensionFile", iRomHdr->iExtensionFile) << endl;
-	DumpInHex("RelocInfo", iRomHdr->iRelocInfo) << endl;
-	DumpInHex("OldTraceMask", iRomHdr->iOldTraceMask) << endl;
-	DumpInHex("UserDataAddress", iRomHdr->iUserDataAddress) << endl;
-	DumpInHex("TotalUserDataSize", iRomHdr->iTotalUserDataSize) << endl;
-	DumpInHex("DebugPort", iRomHdr->iDebugPort) << endl;
-	
-	DumpInHex("Version", iRomHdr->iVersion.iMajor, false, 2);
-	DumpInHex(".", iRomHdr->iVersion.iMinor, aContinue, 2);
-	DumpInHex("(" ,iRomHdr->iVersion.iBuild, aContinue, 2);
+	DumpInHex(const_cast<char *>("RomSize"), iRomHdr->iRomSize) << endl;
+	DumpInHex(const_cast<char *>("KernelDataAddress"), iRomHdr->iKernDataAddress) << endl;
+	DumpInHex(const_cast<char *>("KernelLimit"), iRomHdr->iKernelLimit) << endl;
+	DumpInHex(const_cast<char *>("PrimaryFile"), iRomHdr->iPrimaryFile) << endl;
+	DumpInHex(const_cast<char *>("SecondaryFile"), iRomHdr->iSecondaryFile) << endl;
+	DumpInHex(const_cast<char *>("CheckSum"), iRomHdr->iCheckSum) << endl;
+	DumpInHex(const_cast<char *>("Hardware"), iRomHdr->iHardware) << endl;
+
+	DumpInHex(const_cast<char *>("Language"), (TUint)(iRomHdr->iLanguage >> 32));
+	DumpInHex(const_cast<char *>(" "), ((TUint)(iRomHdr->iLanguage & 0xffffffff)), aContinue) <<endl;
+
+	DumpInHex(const_cast<char *>("KernelConfigFlags"), iRomHdr->iKernelConfigFlags) << endl;
+	DumpInHex(const_cast<char *>("RomExceptionSearchTable"), iRomHdr->iRomExceptionSearchTable) << endl;
+	DumpInHex(const_cast<char *>("RomHeaderSize"), iRomHdr->iRomHeaderSize) << endl;
+	DumpInHex(const_cast<char *>("RomSectionHeader"), iRomHdr->iRomSectionHeader) << endl;
+	DumpInHex(const_cast<char *>("TotalSvDataSize"), iRomHdr->iTotalSvDataSize) << endl;
+	DumpInHex(const_cast<char *>("VariantFile"), iRomHdr->iVariantFile) << endl;
+	DumpInHex(const_cast<char *>("ExtensionFile"), iRomHdr->iExtensionFile) << endl;
+	DumpInHex(const_cast<char *>("RelocInfo"), iRomHdr->iRelocInfo) << endl;
+	DumpInHex(const_cast<char *>("OldTraceMask"), iRomHdr->iOldTraceMask) << endl;
+	DumpInHex(const_cast<char *>("UserDataAddress"), iRomHdr->iUserDataAddress) << endl;
+	DumpInHex(const_cast<char *>("TotalUserDataSize"), iRomHdr->iTotalUserDataSize) << endl;
+	DumpInHex(const_cast<char *>("DebugPort"), iRomHdr->iDebugPort) << endl;
+	
+	DumpInHex(const_cast<char *>("Version"), iRomHdr->iVersion.iMajor, false, 2);
+	DumpInHex(const_cast<char *>("."), iRomHdr->iVersion.iMinor, aContinue, 2);
+	DumpInHex(const_cast<char *>("(") ,iRomHdr->iVersion.iBuild, aContinue, 2);
 	*out << ")" << endl;
 
-	DumpInHex("CompressionType", iRomHdr->iCompressionType) << endl;
-	DumpInHex("CompressedSize", iRomHdr->iCompressedSize) << endl;
-	DumpInHex("UncompressedSize", iRomHdr->iUncompressedSize) << endl;
-	DumpInHex("HcrFileAddress", iRomHdr->iHcrFileAddress) << endl;
+	DumpInHex(const_cast<char *>("CompressionType"), iRomHdr->iCompressionType) << endl;
+	DumpInHex(const_cast<char *>("CompressedSize"), iRomHdr->iCompressedSize) << endl;
+	DumpInHex(const_cast<char *>("UncompressedSize"), iRomHdr->iUncompressedSize) << endl;
+	DumpInHex(const_cast<char *>("HcrFileAddress"), iRomHdr->iHcrFileAddress) << endl;
 	
-	DumpInHex("DisabledCapabilities", iRomHdr->iDisabledCapabilities[0]);
-	DumpInHex(" ", iRomHdr->iDisabledCapabilities[1], aContinue) << endl;
+	DumpInHex(const_cast<char *>("DisabledCapabilities"), iRomHdr->iDisabledCapabilities[0]);
+	DumpInHex(const_cast<char *>(" "), iRomHdr->iDisabledCapabilities[1], aContinue) << endl;
+
+	DumpInHex(const_cast<char *>("TraceMask"), iRomHdr->iTraceMask[0]);
 
-	DumpInHex("TraceMask", iRomHdr->iTraceMask[0]);
 	aPos = 1;
 	while( aPos < (TUint)KNumTraceMaskWords)
 	{
 		if(iRomHdr->iTraceMask[aPos])
 		{
-			DumpInHex(" ", iRomHdr->iTraceMask[aPos++], aContinue);
+			DumpInHex(const_cast<char *>(" "), iRomHdr->iTraceMask[aPos++], aContinue);
 		}
 		else
 		{
-			DumpInHex(" ", iRomHdr->iTraceMask[aPos++], aContinue, 1);
+			DumpInHex(const_cast<char *>(" "), iRomHdr->iTraceMask[aPos++], aContinue, 1);
 		}
 
 	}
@@ -151,22 +158,22 @@
 	*out << "Extension ROM Image" << endl << endl;
 	bool aContinue = true;
 	
-	DumpInHex("Timestamp", (iExtRomHdr->iTime >> 32)) ;
-	DumpInHex(" ", (iExtRomHdr->iTime &0xffffffff), aContinue) << endl;
+	DumpInHex(const_cast<char *>("Timestamp"), (iExtRomHdr->iTime >> 32)) ;
+	DumpInHex(const_cast<char *>(" "), (iExtRomHdr->iTime &0xffffffff), aContinue) << endl;
 
-	DumpInHex("RomBase", iExtRomHdr->iRomBase) << endl;
+	DumpInHex(const_cast<char *>("RomBase"), iExtRomHdr->iRomBase) << endl;
 
-	DumpInHex("RomSize", iExtRomHdr->iRomSize) << endl;
-	DumpInHex("CheckSum", iExtRomHdr->iCheckSum) << endl;
+	DumpInHex(const_cast<char *>("RomSize"), iExtRomHdr->iRomSize) << endl;
+	DumpInHex(const_cast<char *>("CheckSum"), iExtRomHdr->iCheckSum) << endl;
 	
-	DumpInHex("Version", iExtRomHdr->iVersion.iMajor, false, 2);
-	DumpInHex(".", iExtRomHdr->iVersion.iMinor, aContinue, 2);
-	DumpInHex("(" ,iExtRomHdr->iVersion.iBuild, aContinue, 2);
+	DumpInHex(const_cast<char *>("Version"), iExtRomHdr->iVersion.iMajor, false, 2);
+	DumpInHex(const_cast<char *>("."), iExtRomHdr->iVersion.iMinor, aContinue, 2);
+	DumpInHex(const_cast<char *>("(") ,iExtRomHdr->iVersion.iBuild, aContinue, 2);
 	*out << ")" << endl;
 
-	DumpInHex("CompressionType", iExtRomHdr->iCompressionType) << endl;
-	DumpInHex("CompressedSize", iExtRomHdr->iCompressedSize) << endl;
-	DumpInHex("UncompressedSize", iExtRomHdr->iUncompressedSize) << endl;
+	DumpInHex(const_cast<char *>("CompressionType"), iExtRomHdr->iCompressionType) << endl;
+	DumpInHex(const_cast<char *>("CompressedSize"), iExtRomHdr->iCompressedSize) << endl;
+	DumpInHex(const_cast<char *>("UncompressedSize"), iExtRomHdr->iUncompressedSize) << endl;
 	
 	*out << endl << endl;
 
@@ -495,7 +502,7 @@
 
 void RomImageReader::Name(string& aName, const wchar_t* aUnicodeName, TUint aLen)
 {
-	char* temp = (char*)_alloca((aLen << 1) + 1) ;
+	char* temp = (char*)ALLOCA((aLen << 1) + 1) ;
 	size_t n = wcsrtombs(temp,&aUnicodeName,aLen,NULL);
 	if(n == (size_t)-1){ // the unicode string can not be coverted.
 		aName = "???";
@@ -576,31 +583,31 @@
 {
 	bool aContinue = true;
 
-	DumpInHex("Load Address", aEntry->iTRomEntryPtr->iAddressLin) << endl;
-	DumpInHex("Size", aEntry->iTRomEntryPtr->iSize) << endl;
+	DumpInHex(const_cast<char *>("Load Address"), aEntry->iTRomEntryPtr->iAddressLin) << endl;
+	DumpInHex(const_cast<char *>("Size"), aEntry->iTRomEntryPtr->iSize) << endl;
 
 	TRomImageHeader		*aRomImgEntry = aEntry->ImagePtr.iRomFileEntry;
 
 	if( !aRomImgEntry )
 		return;
 	//UIDs
-	DumpInHex("Uids", aRomImgEntry->iUid1);
-	DumpInHex(" ", aRomImgEntry->iUid2, aContinue);
-	DumpInHex(" ", aRomImgEntry->iUid3, aContinue);
-	DumpInHex(" ", aRomImgEntry->iUidChecksum, aContinue) << endl;
-
-	DumpInHex("Entry point", aRomImgEntry->iEntryPoint) << endl;
-	DumpInHex("Code start addr", aRomImgEntry->iCodeAddress) << endl;
-	DumpInHex("Data start addr", aRomImgEntry->iDataAddress) << endl;
-	DumpInHex("DataBssLinearBase", aRomImgEntry->iDataBssLinearBase) << endl;
-	DumpInHex("Text size", aRomImgEntry->iTextSize) << endl;
-	DumpInHex("Code size", aRomImgEntry->iCodeSize) << endl;
-	DumpInHex("Data size", aRomImgEntry->iDataSize) << endl;
-	DumpInHex("Bss size", (aRomImgEntry->iBssSize)) << endl;
-	DumpInHex("Total data size", aRomImgEntry->iTotalDataSize) << endl;
-	DumpInHex("Heap min", aRomImgEntry->iHeapSizeMin) << endl;
-	DumpInHex("Heap max", aRomImgEntry->iHeapSizeMax) << endl;
-	DumpInHex("Stack size", aRomImgEntry->iStackSize) << endl;
+	DumpInHex(const_cast<char *>("Uids"), aRomImgEntry->iUid1);
+	DumpInHex(const_cast<char *>(" "), aRomImgEntry->iUid2, aContinue);
+	DumpInHex(const_cast<char *>(" "), aRomImgEntry->iUid3, aContinue);
+	DumpInHex(const_cast<char *>(" "), aRomImgEntry->iUidChecksum, aContinue) << endl;
+
+	DumpInHex(const_cast<char *>("Entry point"), aRomImgEntry->iEntryPoint) << endl;
+	DumpInHex(const_cast<char *>("Code start addr"), aRomImgEntry->iCodeAddress) << endl;
+	DumpInHex(const_cast<char *>("Data start addr"), aRomImgEntry->iDataAddress) << endl;
+	DumpInHex(const_cast<char *>("DataBssLinearBase"), aRomImgEntry->iDataBssLinearBase) << endl;
+	DumpInHex(const_cast<char *>("Text size"), aRomImgEntry->iTextSize) << endl;
+	DumpInHex(const_cast<char *>("Code size"), aRomImgEntry->iCodeSize) << endl;
+	DumpInHex(const_cast<char *>("Data size"), aRomImgEntry->iDataSize) << endl;
+	DumpInHex(const_cast<char *>("Bss size"), (aRomImgEntry->iBssSize)) << endl;
+	DumpInHex(const_cast<char *>("Total data size"), aRomImgEntry->iTotalDataSize) << endl;
+	DumpInHex(const_cast<char *>("Heap min"), aRomImgEntry->iHeapSizeMin) << endl;
+	DumpInHex(const_cast<char *>("Heap max"), aRomImgEntry->iHeapSizeMax) << endl;
+	DumpInHex(const_cast<char *>("Stack size"), aRomImgEntry->iStackSize) << endl;
 
 	TDllRefTable *aRefTbl = NULL;
 
@@ -608,18 +615,18 @@
 		TUint32 aOff = (TUint32)aRomImgEntry->iDllRefTable - iImageHeader->iRomHdr->iRomBase;
 		aRefTbl = (TDllRefTable*) ((char*)iImageHeader->iRomHdr + aOff);
 		TUint32 aVirtualAddr = (TUint32)aRefTbl->iEntry[0];
-		DumpInHex("Dll ref table", aVirtualAddr) << endl;
+		DumpInHex(const_cast<char *>("Dll ref table"), aVirtualAddr) << endl;
 	}
 
-	DumpInHex("Export directory", aRomImgEntry->iExportDir) << endl;
-	DumpInHex("Export dir count", aRomImgEntry->iExportDirCount) << endl;
-	DumpInHex("Hardware variant", aRomImgEntry->iHardwareVariant) << endl;
-	DumpInHex("Flags", aRomImgEntry->iFlags) << endl;
-	DumpInHex("Secure ID", aRomImgEntry->iS.iSecureId) << endl;
-	DumpInHex("Vendor ID", aRomImgEntry->iS.iVendorId) << endl;
+	DumpInHex(const_cast<char *>("Export directory"), aRomImgEntry->iExportDir) << endl;
+	DumpInHex(const_cast<char *>("Export dir count"), aRomImgEntry->iExportDirCount) << endl;
+	DumpInHex(const_cast<char *>("Hardware variant"), aRomImgEntry->iHardwareVariant) << endl;
+	DumpInHex(const_cast<char *>("Flags"), aRomImgEntry->iFlags) << endl;
+	DumpInHex(const_cast<char *>("Secure ID"), aRomImgEntry->iS.iSecureId) << endl;
+	DumpInHex(const_cast<char *>("Vendor ID"), aRomImgEntry->iS.iVendorId) << endl;
 
-	DumpInHex("Capability", aRomImgEntry->iS.iCaps[1]);
-	DumpInHex(" ", aRomImgEntry->iS.iCaps[0], aContinue) << endl;
+	DumpInHex(const_cast<char *>("Capability"), aRomImgEntry->iS.iCaps[1]);
+	DumpInHex(const_cast<char *>(" "), aRomImgEntry->iS.iCaps[0], aContinue) << endl;
 	
 	*out << "Tools Version..............." << dec << (TUint)aRomImgEntry->iToolsVersion.iMajor;
 	*out << "." ; 
@@ -630,13 +637,13 @@
 	*out << endl;
 
 	*out << "Module Version.............." << dec << (aRomImgEntry->iModuleVersion >> 16) << endl;
-	DumpInHex("Exception Descriptor", aRomImgEntry->iExceptionDescriptor) << endl;
+	DumpInHex(const_cast<char *>("Exception Descriptor"), aRomImgEntry->iExceptionDescriptor) << endl;
 	*out << "Priority...................." << dec << aRomImgEntry->iPriority << endl;
 
 	if( aRefTbl )
-		DumpInHex("Dll ref table size", aRefTbl->iNumberOfEntries*8) << endl;
+		DumpInHex(const_cast<char *>("Dll ref table size"), aRefTbl->iNumberOfEntries*8) << endl;
 	else
-		DumpInHex("Dll ref table size", 0) << endl;
+		DumpInHex(const_cast<char *>("Dll ref table size"), 0) << endl;
 
 	if( iDisplayOptions & DUMP_E32_IMG_FLAG){
 		if(stricmp(iE32ImgFileName.c_str(), aEntry->Name()) == 0){
@@ -695,8 +702,8 @@
 	*out << left << prefix;
 	out->width(40);	
 	*out << right << file->Name() << "[" ;
-	DumpInHex( "", aRomImgEntry->iHardwareVariant, true) << "] ";
-	DumpInHex( " DataSize=", (aRomImgEntry->iBssSize + aRomImgEntry->iDataSize), true) << endl;
+	DumpInHex( const_cast<char *>(""), aRomImgEntry->iHardwareVariant, true) << "] ";
+	DumpInHex( const_cast<char *>(" DataSize="), (aRomImgEntry->iBssSize + aRomImgEntry->iDataSize), true) << endl;
 	
 }
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_build.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_build.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_build.cpp	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_build.cpp	2010-05-08 15:04:00.000000000 +0100
@@ -29,7 +29,7 @@
 
 #if defined(__MSVCDOTNET__) || defined(__TOOLS2__)
 	#include <iomanip>
-	#include <strstream>
+	#include <sstream>
 #else //!__MSVCDOTNET__
 	#include <iomanip.h>
 #endif //__MSVCDOTNET__
@@ -1218,22 +1218,11 @@
 				f.UpdateHeaderCrc();
 				if (overflow)
 					{
-					char * buffer = new char [size];
-					// need to check if the compressed file will fit in the image
-   					#if defined(__LINUX__)
- 					ostrstream os((char*)aDest, aMaxSize, (ios::openmode)(ios::out+ios::binary));
-					#elif defined(__TOOLS2__) && defined (_STLP_THREADS)
-  					ostrstream os((char*)buffer, size,(ios::out+ios::binary));
-  					#elif defined( __TOOLS2__)
-   					ostrstream os((char*)buffer, size,(ios::out+ios::binary));
-					#else
-					ostrstream os( (char*)buffer, size, (ios::out+ios::binary));
-					#endif
+					ostringstream os(ios_base::out|ios_base::binary);
 					os << f;
-					TUint compressedSize = os.pcount();
+					TUint compressedSize = os.str().size();
 					if (compressedSize <= aMaxSize)
 						overflow = EFalse;	
-					delete[] buffer;
 					}
 				}
 			if (overflow)
@@ -1242,15 +1231,9 @@
 				Print(EError, "Overflowed by approximately 0x%x bytes.\n", size - aMaxSize);
 				exit(667);
 				}
-  			#if defined(__TOOLS2__) && defined (_STLP_THREADS)
-  			ostrstream os((char*)aDest, aMaxSize,(ios::out+ios::binary));
-  			#elif __TOOLS2__
-			ostrstream os((char*)aDest, aMaxSize, (std::_Ios_Openmode)(ios::out+ios::binary));
-			#else
-			ostrstream os((char*)aDest, aMaxSize, (ios::out+ios::binary));
-			#endif
+  			ostringstream os(ios_base::out|ios_base::binary);
 			os << f;
-			size = os.pcount();
+			size = os.str().size();
 			compression = f.iHdr->CompressionType();
 			memcpy(&iUids[0], aDest, sizeof(iUids));
 			}
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_coreimage.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_coreimage.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_coreimage.cpp	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_coreimage.cpp	2010-05-08 15:06:54.000000000 +0100
@@ -99,7 +99,7 @@
 TInt RCoreImageReader::ReadIdentifier()
 	{
 	int itemsRead = fread(&iIdentifier, sizeof(TUint8), K_ID_SIZE, iCoreImage);
-	TInt result = ImageError(itemsRead,  K_ID_SIZE, "Read Identifier");
+	TInt result = ImageError(itemsRead,  K_ID_SIZE, const_cast<char *>("Read Identifier"));
 	if (result != KErrNone)
 		{
 		iIdentifier[0] = 0;
@@ -117,7 +117,7 @@
 	{
 	int itemsRead = fread (&aHeader.iHeaderSize, 
 			(sizeof(TRofsHeader)) - K_ID_SIZE*sizeof(TUint8), 1, iCoreImage);
-	TInt result = ImageError(itemsRead, 1, "Read Core Header");
+	TInt result = ImageError(itemsRead, 1, const_cast<char *>("Read Core Header"));
 	if (result == KErrNone)
 		{
 		// copy the previously read identifier into the header
@@ -137,7 +137,7 @@
 	{
 	int itemsRead = fread (&aHeader.iHeaderSize, 
 			(sizeof(TExtensionRofsHeader)) - K_ID_SIZE*sizeof(TUint8), 1, iCoreImage);
-	TInt result = ImageError(itemsRead, 1, "Read Extension Header");
+	TInt result = ImageError(itemsRead, 1, const_cast<char *>("Read Extension Header"));
 	if (result == KErrNone)
 		{
 		// copy the previously read identifier into the header
@@ -199,7 +199,7 @@
 	// is read later when handling subdirectories
 	int bytesRead = sizeof(TRofsDir) - sizeof(TRofsEntry);
 	int itemsRead = fread (&aDir, bytesRead , 1, iCoreImage);
-	if (ImageError(itemsRead, 1, "Read Dir") == KErrNone)
+	if (ImageError(itemsRead, 1, const_cast<char *>("Read Dir")) == KErrNone)
 		return bytesRead;
 	else
 		return 0;
@@ -233,13 +233,13 @@
 	// need to work out how big entry needs to be from the Struct Size
 	// in TRofsEntry
 	int itemsRead = fread(&aEntry.iStructSize, sizeof(TUint16), 1, iCoreImage);
-	int result = ImageError(itemsRead, 1, "Read Entry Size");
+	int result = ImageError(itemsRead, 1, const_cast<char *>("Read Entry Size"));
 	if (result == KErrNone)
 		{
 		// read rest of entry excluding the iStructSize
 		itemsRead = fread(&aEntry.iUids[0], sizeof(TRofsEntry) -sizeof(TUint16), 
 				          1, iCoreImage);
-		result = ImageError(itemsRead, 1, "Rest of Entry");
+		result = ImageError(itemsRead, 1, const_cast<char *>("Rest of Entry"));
 		// return length read - this include includes iStructSize and first char of name
 		if (result == KErrNone)
 			return sizeof(TRofsEntry);	
@@ -270,7 +270,7 @@
 TInt RCoreImageReader::ReadRofEntryName(TUint16* aName, int aLength)
 	{
 	int itemsRead = fread(aName, sizeof(TUint16), aLength, iCoreImage);
-	return ImageError(itemsRead, aLength, "Rof Entry Name");
+	return ImageError(itemsRead, aLength, const_cast<char *>("Rof Entry Name"));
 	}
 
 /**
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_driveimage.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_driveimage.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_driveimage.cpp	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_driveimage.cpp	2010-04-21 13:27:26.000000000 +0100
@@ -254,7 +254,7 @@
 	fileName.append("/");
 
 	// Go through each entry
-	while(dirEntry = readdir(dirHandler))
+	while((dirEntry = readdir(dirHandler)) != NULL)
 		{
 		if(dirEntry->d_type != DT_DIR) 
 			{
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_driveutl.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_driveutl.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_driveutl.cpp	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_driveutl.cpp	2010-05-08 15:05:24.000000000 +0100
@@ -82,7 +82,7 @@
 /**
 Time Stamp for Log file.
 */ 
-TAny GetLocalTime(TAny)
+TAny GetLocalTime()
 	{
 	struct tm *aNewTime = NULL;
 	time_t aTime = 0;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_driveutl.h /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_driveutl.h
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_driveutl.h	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_driveutl.h	2010-05-08 15:08:42.000000000 +0100
@@ -24,6 +24,6 @@
 #include <e32def.h>
 
 TInt Getlogfile(TText *aDriveObeyFileName,TText* &aPadLogFile);
-TAny GetLocalTime(TAny);
+TAny GetLocalTime();
 
 #endif
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_obey.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_obey.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_obey.cpp	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_obey.cpp	2010-05-08 15:04:50.000000000 +0100
@@ -283,7 +283,7 @@
 	iCurrentLine++;
 	iCurrentMark = ftell(iObeyFile);
 	iLine[0]='\0';
-	fgets((char*)iLine,imaxLength+1,iObeyFile);
+	char *cp = fgets((char*)iLine,imaxLength+1,iObeyFile); (void)cp;
 	iCurrentObeyStatement = new TText[imaxLength+1];
 	strcpy((char*)iCurrentObeyStatement,(char*)iLine);
 	iNumWords = Parse();
@@ -646,13 +646,7 @@
 		{
 		  if (keyword == EKeywordCoreImage)
 			  {
-  			  #if defined(__TOOLS2__) && defined (_STLP_THREADS)
-  			  istringstream val(iReader.Word(1),(ios_base::in+ios_base::out));	  
-  			  #elif __TOOLS2__
-  			  istringstream val(iReader.Word(1),(std::_Ios_Openmode)(ios_base::in+ios_base::out));
-			  #else
-			  istrstream val(iReader.Word(1),strlen(iReader.Word(1)));
-			  #endif
+			istringstream val(iReader.Word(1),ios_base::in|ios_base::out);	  
 			  iReader.CopyWord(1, coreImageFileName);
 			  iReader.MarkNext(); // ready for processing extension
 			  break;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/rofsbuild.mmp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/rofsbuild.mmp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/rofsbuild.mmp	2010-05-10 19:22:13.797117735 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/rofsbuild.mmp	2010-05-08 15:07:32.000000000 +0100
@@ -43,15 +43,16 @@
 USERINCLUDE   ../../imglib/inc ../../imglib/compress ../../imglib/filesystem/include 
 USERINCLUDE   ../../imglib/patchdataprocessor/include ../../imglib/parameterfileprocessor/include
 USERINCLUDE	  ../../imglib/memmap/include
+#ifndef TOOLS2_LINUX
 USERINCLUDE   ../../imglib/boostlibrary/
+#endif
 
 STATICLIBRARY 	filesystem 
 STATICLIBRARY   patchdataprocessor
 STATICLIBRARY   parameterfileprocessor
 STATICLIBRARY	memmap
 #ifdef TOOLS2_LINUX
-STATICLIBRARY   boost_thread-mgw34-mt-1_39_linux
-OPTION    GCC -pthread -O2 -Wno-uninitialized
+OPTION    GCC -pthread -O2 -Wno-uninitialized -lboost_thread-mt
 #else
 STATICLIBRARY   boost_thread-mgw34-mt-1_39_win32
 OPTION    GCC -mthreads -O2 -Wno-uninitialized
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_rofs.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_rofs.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rofsbuild/r_rofs.cpp	2010-05-10 19:22:13.793117226 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rofsbuild/r_rofs.cpp	2010-05-08 15:08:18.000000000 +0100
@@ -584,9 +584,10 @@
 			coffhead[0x54] = 0x20;
 
 			// now fill in the text segment size
-			*(TUint32 *) (&coffhead[0x18]) = ALIGN4K(iSizeUsed);
-			*(TUint32 *) (&coffhead[0x40]) = ALIGN4K(iSizeUsed);
-
+			TUint32 * p0x18 = reinterpret_cast<TUint32 *>(&coffhead[0x18]);
+			*p0x18 = ALIGN4K(iSizeUsed);
+			TUint32 * p0x40 = reinterpret_cast<TUint32 *>(&coffhead[0x40]);
+			*p0x40 = ALIGN4K(iSizeUsed);
 			os.write(reinterpret_cast<char *>(coffhead), sizeof(coffhead));
 			}
 		break;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rombuild/r_obey.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rombuild/r_obey.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rombuild/r_obey.cpp	2010-05-10 19:22:13.805117355 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rombuild/r_obey.cpp	2010-05-08 14:50:44.000000000 +0100
@@ -301,7 +301,7 @@
 	iCurrentLine++;
 	iCurrentMark = ftell(iObeyFile);
 	iLine[0]='\0';
-	fgets((char*)iLine,imaxLength+1,iObeyFile);
+	char * cp = fgets((char*)iLine,imaxLength+1,iObeyFile); (void)cp;
 	iNumWords = Parse();
 	return KErrNone;
 	}
@@ -2973,13 +2973,7 @@
 	{
 		if (keyword == EKeywordCoreImage)
 		{
-#if defined(__TOOLS2__) && defined (_STLP_THREADS)
-			istringstream val(iReader.Word(1),(ios_base::in+ios_base::out));	  
-#elif __TOOLS2__
-			istringstream val(iReader.Word(1),(std::_Ios_Openmode)(ios_base::in+ios_base::out));
-#else
-			istrstream val(iReader.Word(1),strlen(iReader.Word(1)));
-#endif
+			istringstream val(iReader.Word(1),ios_base::in|ios_base::out);
 			iReader.CopyWord(1, coreImageFileName);
 			break;
 		}
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rombuild/rombuild.mmp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rombuild/rombuild.mmp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rombuild/rombuild.mmp	2010-05-10 19:22:13.809118004 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rombuild/rombuild.mmp	2010-05-08 14:52:22.000000000 +0100
@@ -41,7 +41,9 @@
 userinclude	../../imglib/compress 	../../imglib/inc 
 userinclude	../../imglib/patchdataprocessor/include ../../imglib/parameterfileprocessor/include
 userinclude ../../imglib/memmap/include
+#ifndef TOOLS2_LINUX
 userinclude	../../imglib/boostlibrary/
+#endif
 
 OS_LAYER_SYSTEMINCLUDE_SYMBIAN
 
@@ -50,8 +52,7 @@
 staticlibrary 	memmap
 
 #ifdef TOOLS2_LINUX
-STATICLIBRARY   boost_thread-mgw34-mt-1_39_linux
-OPTION    GCC -O2 -Wno-uninitialized -pthread
+OPTION    GCC -pthread -O2 -Wno-uninitialized -lboost_thread-mt
 #else
 STATICLIBRARY   boost_thread-mgw34-mt-1_39_win32
 OPTION    GCC -O2 -Wno-uninitialized -mthreads
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rombuild/r_rom.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rombuild/r_rom.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/rombuild/r_rom.cpp	2010-05-10 19:22:13.805117355 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/rombuild/r_rom.cpp	2010-05-08 14:51:46.000000000 +0100
@@ -1835,7 +1835,7 @@
 			TRomFile** l=rf->iPDeps;
 			FindMarked(MARK_EXE, MARK_EXE, l);
 			TInt nx=l-rf->iPDeps;
-			if (!e->IsDll() && (nx>1 || nx==1 && l[-1]!=rf))
+			if (!e->IsDll() && (nx>1 || (nx==1 && l[-1]!=rf)))
 				{
 				Print(EError,"EXE %s links to the following other EXEs:\n", e->iFileName);
 				TInt j;
@@ -2198,8 +2198,11 @@
 			coffhead[0x54] = 0x20;
 
 			// now fill in the text segment size
-			*(TUint32 *) (&coffhead[0x18]) = ALIGN4K(iSizeUsed);
-			*(TUint32 *) (&coffhead[0x40]) = ALIGN4K(iSizeUsed);
+			TUint32 * p0x18 = reinterpret_cast<TUint32 *>(&coffhead[0x18]);
+			*p0x18 = ALIGN4K(iSizeUsed);
+			TUint32 * p0x40 = reinterpret_cast<TUint32 *>(&coffhead[0x40]);
+			*p0x40 = ALIGN4K(iSizeUsed);
+
 
 			os.write(reinterpret_cast<char *>(coffhead), sizeof(coffhead));
 			}
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/sisutils/inc/pkgfileparser.h /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/sisutils/inc/pkgfileparser.h
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/sisutils/inc/pkgfileparser.h	2010-05-10 19:22:13.849689642 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/sisutils/inc/pkgfileparser.h	2010-05-08 15:20:36.000000000 +0100
@@ -33,6 +33,10 @@
 
 #include "pkglanguage.h"
 
+int CompareTwoString(wchar_t const * string ,wchar_t const * option);
+int CompareNString(wchar_t const * string ,wchar_t const * option, int len);
+
+
 typedef class PkgParser PKGPARSER, *PPKGPARSER;
 
 //Data structures for pkg file parsing
@@ -147,7 +151,7 @@
 	int OpenFile();
 	void DeleteAll();
 
-	HANDLE iPkgHandle;
+	FILE * iPkgHandle;
 
 	LANGUAGE_LIST iLangList;
 	PKG_HEADER iPkgHeader;
@@ -162,7 +166,7 @@
 	void GetNextChar();
 	void GetNextToken();
 	bool GetStringToken();
-	WORD ParseEscapeChars();
+	unsigned short ParseEscapeChars();
 	void GetAlphaNumericToken();
 	bool IsNumericToken();
 	void GetNumericToken();
@@ -197,8 +201,8 @@
 
 	friend String wstring2string (const std::wstring& aWide);
 	friend std::wstring string2wstring (const String& aNarrow);
-	friend int CompareTwoString(wchar_t* string ,wchar_t* option);
-	friend int CompareNString(wchar_t* string ,wchar_t* option, int len);
+    friend int CompareTwoString(wchar_t const * string ,wchar_t const * option);
+    friend int CompareNString(wchar_t const * string ,wchar_t const * option, int len);
 };
 
 #endif //__PKGFILEPARSER_H__
